diff --git a/doc/guides/prog_guide/env_abstraction_layer.rst b/doc/guides/prog_guide/env_abstraction_layer.rst
index 3f33621e05..93c8a031be 100644
--- a/doc/guides/prog_guide/env_abstraction_layer.rst
+++ b/doc/guides/prog_guide/env_abstraction_layer.rst
@@ -550,8 +550,9 @@ Some general comments:
   waiving checks with ``__rte_no_thread_safety_analysis`` in your code, please
   discuss it on the mailing list,
 
-A DPDK library/driver can enable/disable the checks by setting
-``annotate_locks`` accordingly in its ``meson.build`` file.
+The checks are enabled by default for libraries and drivers.
+They can be disabled by setting ``annotate_locks`` to ``false`` in
+the concerned library/driver ``meson.build``.
 
 IOVA Mode Detection
 ~~~~~~~~~~~~~~~~~~~
diff --git a/drivers/bus/dpaa/meson.build b/drivers/bus/dpaa/meson.build
index 5506f2bffc..183b251459 100644
--- a/drivers/bus/dpaa/meson.build
+++ b/drivers/bus/dpaa/meson.build
@@ -29,3 +29,4 @@ if cc.has_argument('-Wno-pointer-arith')
 endif
 
 includes += include_directories('include', 'base/qbman')
+annotate_locks = false
diff --git a/drivers/common/cnxk/meson.build b/drivers/common/cnxk/meson.build
index 849735921c..9beb1cddba 100644
--- a/drivers/common/cnxk/meson.build
+++ b/drivers/common/cnxk/meson.build
@@ -88,3 +88,4 @@ sources += files('cnxk_telemetry_bphy.c',
 
 deps += ['bus_pci', 'net', 'telemetry']
 pmd_supports_disable_iova_as_pa = true
+annotate_locks = false
diff --git a/drivers/common/mlx5/meson.build b/drivers/common/mlx5/meson.build
index 60ccd95cbc..d38255dc82 100644
--- a/drivers/common/mlx5/meson.build
+++ b/drivers/common/mlx5/meson.build
@@ -40,3 +40,4 @@ endif
 mlx5_config = configuration_data()
 subdir(exec_env)
 configure_file(output: 'mlx5_autoconf.h', configuration: mlx5_config)
+annotate_locks = false
diff --git a/drivers/event/cnxk/meson.build b/drivers/event/cnxk/meson.build
index aa42ab3a90..20c6a0484a 100644
--- a/drivers/event/cnxk/meson.build
+++ b/drivers/event/cnxk/meson.build
@@ -480,3 +480,4 @@ endforeach
 
 deps += ['bus_pci', 'common_cnxk', 'net_cnxk', 'crypto_cnxk']
 pmd_supports_disable_iova_as_pa = true
+annotate_locks = false
diff --git a/drivers/meson.build b/drivers/meson.build
index 0618c31a69..d529980fc5 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -91,7 +91,7 @@ foreach subpath:subdirs
         build = true # set to false to disable, e.g. missing deps
         reason = '<unknown reason>' # set if build == false to explain
         name = drv
-        annotate_locks = false
+        annotate_locks = true
         sources = []
         headers = []
         driver_sdk_headers = [] # public headers included by drivers
diff --git a/drivers/net/bnx2x/meson.build b/drivers/net/bnx2x/meson.build
index 156f97d31f..dbf9c7225d 100644
--- a/drivers/net/bnx2x/meson.build
+++ b/drivers/net/bnx2x/meson.build
@@ -21,3 +21,4 @@ sources = files(
         'ecore_sp.c',
         'elink.c',
 )
+annotate_locks = false
diff --git a/drivers/net/bnxt/meson.build b/drivers/net/bnxt/meson.build
index 09d494e90f..f43dbfc445 100644
--- a/drivers/net/bnxt/meson.build
+++ b/drivers/net/bnxt/meson.build
@@ -68,3 +68,4 @@ if arch_subdir == 'x86'
 elif arch_subdir == 'arm' and dpdk_conf.get('RTE_ARCH_64')
     sources += files('bnxt_rxtx_vec_neon.c')
 endif
+annotate_locks = false
diff --git a/drivers/net/cnxk/meson.build b/drivers/net/cnxk/meson.build
index c7ca24d437..86ed2d13dd 100644
--- a/drivers/net/cnxk/meson.build
+++ b/drivers/net/cnxk/meson.build
@@ -196,3 +196,4 @@ endforeach
 
 headers = files('rte_pmd_cnxk.h')
 pmd_supports_disable_iova_as_pa = true
+annotate_locks = false
diff --git a/drivers/net/enic/meson.build b/drivers/net/enic/meson.build
index 7131a25f09..1523511ba5 100644
--- a/drivers/net/enic/meson.build
+++ b/drivers/net/enic/meson.build
@@ -39,3 +39,4 @@ elif cc.has_argument('-mavx2') and dpdk_conf.get('RTE_ARCH_64')
             c_args: [cflags, '-mavx2'])
     objs += enic_avx2_lib.extract_objects('enic_rxtx_vec_avx2.c')
 endif
+annotate_locks = false
diff --git a/drivers/net/hns3/meson.build b/drivers/net/hns3/meson.build
index e1a5afa2ec..43e52e6107 100644
--- a/drivers/net/hns3/meson.build
+++ b/drivers/net/hns3/meson.build
@@ -38,6 +38,7 @@ sources = files(
         'hns3_common.c',
         'hns3_dump.c',
 )
+annotate_locks = false
 
 deps += ['hash']
 
diff --git a/drivers/net/mlx5/meson.build b/drivers/net/mlx5/meson.build
index abd507bd88..5e7d0d4e1a 100644
--- a/drivers/net/mlx5/meson.build
+++ b/drivers/net/mlx5/meson.build
@@ -79,3 +79,4 @@ testpmd_sources += files('mlx5_testpmd.c')
 subdir(exec_env)
 
 subdir('hws')
+annotate_locks = false
diff --git a/lib/ipsec/meson.build b/lib/ipsec/meson.build
index 0b8b935cd2..ff44d6fbdf 100644
--- a/lib/ipsec/meson.build
+++ b/lib/ipsec/meson.build
@@ -13,5 +13,6 @@ sources = files('esp_inb.c', 'esp_outb.c',
 
 headers = files('rte_ipsec.h', 'rte_ipsec_sa.h', 'rte_ipsec_sad.h')
 indirect_headers += files('rte_ipsec_group.h')
+annotate_locks = false
 
 deps += ['mbuf', 'net', 'cryptodev', 'security', 'hash', 'telemetry']
diff --git a/lib/meson.build b/lib/meson.build
index 2bc0932ad5..9b5e412454 100644
--- a/lib/meson.build
+++ b/lib/meson.build
@@ -120,7 +120,7 @@ foreach l:libraries
     reason = '<unknown reason>' # set if build == false to explain why
     name = l
     use_function_versioning = false
-    annotate_locks = false
+    annotate_locks = true
     sources = []
     headers = []
     indirect_headers = [] # public headers not directly included by apps
diff --git a/lib/timer/meson.build b/lib/timer/meson.build
index 89b17e0397..87bbb10592 100644
--- a/lib/timer/meson.build
+++ b/lib/timer/meson.build
@@ -3,3 +3,4 @@
 
 sources = files('rte_timer.c')
 headers = files('rte_timer.h')
+annotate_locks = false
diff --git a/lib/vhost/meson.build b/lib/vhost/meson.build
index 197a51d936..0d1abf6283 100644
--- a/lib/vhost/meson.build
+++ b/lib/vhost/meson.build
@@ -18,7 +18,6 @@ endif
 dpdk_conf.set('RTE_LIBRTE_VHOST_POSTCOPY', cc.has_header('linux/userfaultfd.h'))
 cflags += '-fno-strict-aliasing'
 
-annotate_locks = true
 sources = files(
         'fd_man.c',
         'iotlb.c',