diff --git a/doc/guides/prog_guide/env_abstraction_layer.rst b/doc/guides/prog_guide/env_abstraction_layer.rst
index 3f33621e05..93c8a031be 100644
--- a/doc/guides/prog_guide/env_abstraction_layer.rst
+++ b/doc/guides/prog_guide/env_abstraction_layer.rst
@@ -550,8 +550,9 @@ Some general comments:
   waiving checks with ``__rte_no_thread_safety_analysis`` in your code, please
   discuss it on the mailing list,
 
-A DPDK library/driver can enable/disable the checks by setting
-``annotate_locks`` accordingly in its ``meson.build`` file.
+The checks are enabled by default for libraries and drivers.
+They can be disabled by setting ``annotate_locks`` to ``false`` in
+the concerned library/driver ``meson.build``.
 
 IOVA Mode Detection
 ~~~~~~~~~~~~~~~~~~~
diff --git a/drivers/bus/dpaa/meson.build b/drivers/bus/dpaa/meson.build
index 5506f2bffc..183b251459 100644
--- a/drivers/bus/dpaa/meson.build
+++ b/drivers/bus/dpaa/meson.build
@@ -29,3 +29,4 @@ if cc.has_argument('-Wno-pointer-arith')
 endif
 
 includes += include_directories('include', 'base/qbman')
+annotate_locks = false
diff --git a/drivers/common/cnxk/meson.build b/drivers/common/cnxk/meson.build
index 402c3249cd..b32fae9f5a 100644
--- a/drivers/common/cnxk/meson.build
+++ b/drivers/common/cnxk/meson.build
@@ -89,3 +89,4 @@ sources += files('cnxk_telemetry_bphy.c',
 
 deps += ['bus_pci', 'net', 'telemetry']
 require_iova_in_mbuf = false
+annotate_locks = false
diff --git a/drivers/common/mlx5/meson.build b/drivers/common/mlx5/meson.build
index 9dc809f192..b5fc4c9346 100644
--- a/drivers/common/mlx5/meson.build
+++ b/drivers/common/mlx5/meson.build
@@ -45,3 +45,4 @@ endif
 mlx5_config = configuration_data()
 subdir(exec_env)
 configure_file(output: 'mlx5_autoconf.h', configuration: mlx5_config)
+annotate_locks = false
diff --git a/drivers/event/cnxk/meson.build b/drivers/event/cnxk/meson.build
index 3517e79341..89e1aa860f 100644
--- a/drivers/event/cnxk/meson.build
+++ b/drivers/event/cnxk/meson.build
@@ -480,3 +480,4 @@ endforeach
 
 deps += ['bus_pci', 'common_cnxk', 'net_cnxk', 'crypto_cnxk']
 require_iova_in_mbuf = false
+annotate_locks = false
diff --git a/drivers/meson.build b/drivers/meson.build
index b85bec235d..74ae8cb96b 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -92,7 +92,7 @@ foreach subpath:subdirs
         build = true # set to false to disable, e.g. missing deps
         reason = '<unknown reason>' # set if build == false to explain
         name = drv
-        annotate_locks = false
+        annotate_locks = true
         sources = []
         headers = []
         driver_sdk_headers = [] # public headers included by drivers
diff --git a/drivers/net/bnx2x/meson.build b/drivers/net/bnx2x/meson.build
index 156f97d31f..dbf9c7225d 100644
--- a/drivers/net/bnx2x/meson.build
+++ b/drivers/net/bnx2x/meson.build
@@ -21,3 +21,4 @@ sources = files(
         'ecore_sp.c',
         'elink.c',
 )
+annotate_locks = false
diff --git a/drivers/net/bnxt/meson.build b/drivers/net/bnxt/meson.build
index 0288ed6262..72d4f82e7c 100644
--- a/drivers/net/bnxt/meson.build
+++ b/drivers/net/bnxt/meson.build
@@ -72,3 +72,4 @@ if arch_subdir == 'x86'
 elif arch_subdir == 'arm' and dpdk_conf.get('RTE_ARCH_64')
     sources += files('bnxt_rxtx_vec_neon.c')
 endif
+annotate_locks = false
diff --git a/drivers/net/cnxk/meson.build b/drivers/net/cnxk/meson.build
index 8b5773ce65..abece91e40 100644
--- a/drivers/net/cnxk/meson.build
+++ b/drivers/net/cnxk/meson.build
@@ -197,3 +197,4 @@ endforeach
 headers = files('rte_pmd_cnxk.h')
 
 require_iova_in_mbuf = false
+annotate_locks = false
diff --git a/drivers/net/enic/meson.build b/drivers/net/enic/meson.build
index 0a0992c3cb..bde7428953 100644
--- a/drivers/net/enic/meson.build
+++ b/drivers/net/enic/meson.build
@@ -43,3 +43,4 @@ elif cc.has_argument('-mavx2') and dpdk_conf.get('RTE_ARCH_64')
             c_args: [cflags, '-mavx2'])
     objs += enic_avx2_lib.extract_objects('enic_rxtx_vec_avx2.c')
 endif
+annotate_locks = false
diff --git a/drivers/net/failsafe/meson.build b/drivers/net/failsafe/meson.build
index 3066d37995..6013e13722 100644
--- a/drivers/net/failsafe/meson.build
+++ b/drivers/net/failsafe/meson.build
@@ -29,3 +29,7 @@ sources = files(
 )
 
 require_iova_in_mbuf = false
+
+if is_freebsd
+    annotate_locks = false
+endif
diff --git a/drivers/net/hinic/meson.build b/drivers/net/hinic/meson.build
index dbcf177782..8242e0052e 100644
--- a/drivers/net/hinic/meson.build
+++ b/drivers/net/hinic/meson.build
@@ -18,3 +18,7 @@ sources = files(
 )
 
 includes += include_directories('base')
+
+if is_freebsd
+    annotate_locks = false
+endif
diff --git a/drivers/net/hns3/meson.build b/drivers/net/hns3/meson.build
index 97cb85dcc8..7dcf21f72a 100644
--- a/drivers/net/hns3/meson.build
+++ b/drivers/net/hns3/meson.build
@@ -32,6 +32,7 @@ sources = files(
         'hns3_common.c',
         'hns3_dump.c',
 )
+annotate_locks = false
 
 require_iova_in_mbuf = false
 
diff --git a/drivers/net/mlx5/meson.build b/drivers/net/mlx5/meson.build
index dba911693e..3184a41a25 100644
--- a/drivers/net/mlx5/meson.build
+++ b/drivers/net/mlx5/meson.build
@@ -82,3 +82,4 @@ testpmd_sources += files('mlx5_testpmd.c')
 subdir(exec_env)
 
 subdir('hws')
+annotate_locks = false
diff --git a/lib/eal/meson.build b/lib/eal/meson.build
index 056beb9461..9aa941a5ae 100644
--- a/lib/eal/meson.build
+++ b/lib/eal/meson.build
@@ -32,3 +32,7 @@ endif
 if cc.has_function('getentropy', prefix : '#include <unistd.h>')
     cflags += '-DRTE_LIBEAL_USE_GETENTROPY'
 endif
+
+if is_freebsd
+    annotate_locks = false
+endif
diff --git a/lib/ethdev/meson.build b/lib/ethdev/meson.build
index 9e97f05983..1ba0fac5c0 100644
--- a/lib/ethdev/meson.build
+++ b/lib/ethdev/meson.build
@@ -44,3 +44,7 @@ driver_sdk_headers += files(
 )
 
 deps += ['net', 'kvargs', 'meter', 'telemetry']
+
+if is_freebsd
+    annotate_locks = false
+endif
diff --git a/lib/ipsec/meson.build b/lib/ipsec/meson.build
index 0b8b935cd2..ff44d6fbdf 100644
--- a/lib/ipsec/meson.build
+++ b/lib/ipsec/meson.build
@@ -13,5 +13,6 @@ sources = files('esp_inb.c', 'esp_outb.c',
 
 headers = files('rte_ipsec.h', 'rte_ipsec_sa.h', 'rte_ipsec_sad.h')
 indirect_headers += files('rte_ipsec_group.h')
+annotate_locks = false
 
 deps += ['mbuf', 'net', 'cryptodev', 'security', 'hash', 'telemetry']
diff --git a/lib/meson.build b/lib/meson.build
index 0812ce6026..dc8aa4ac84 100644
--- a/lib/meson.build
+++ b/lib/meson.build
@@ -121,7 +121,7 @@ foreach l:libraries
     reason = '<unknown reason>' # set if build == false to explain why
     name = l
     use_function_versioning = false
-    annotate_locks = false
+    annotate_locks = true
     sources = []
     headers = []
     indirect_headers = [] # public headers not directly included by apps
diff --git a/lib/timer/meson.build b/lib/timer/meson.build
index 89b17e0397..87bbb10592 100644
--- a/lib/timer/meson.build
+++ b/lib/timer/meson.build
@@ -3,3 +3,4 @@
 
 sources = files('rte_timer.c')
 headers = files('rte_timer.h')
+annotate_locks = false
diff --git a/lib/vhost/meson.build b/lib/vhost/meson.build
index 197a51d936..0d1abf6283 100644
--- a/lib/vhost/meson.build
+++ b/lib/vhost/meson.build
@@ -18,7 +18,6 @@ endif
 dpdk_conf.set('RTE_LIBRTE_VHOST_POSTCOPY', cc.has_header('linux/userfaultfd.h'))
 cflags += '-fno-strict-aliasing'
 
-annotate_locks = true
 sources = files(
         'fd_man.c',
         'iotlb.c',